﻿<%@ Page Language="C#" MasterPageFile="~/Admin/Admin.master" AutoEventWireup="true" CodeFile="PaymentManager.aspx.cs" Inherits="Admin_Orders_PaymentManager" Title="Payment Manager" %>
<%@ Register Assembly="CommerceBuilder.Web" Namespace="CommerceBuilder.Web.UI.WebControls" TagPrefix="cb" %>
<%@ Register Assembly="ComponentArt.Web.UI" Namespace="ComponentArt.Web.UI" TagPrefix="ComponentArt" %>
<%@ Register Src="../UserControls/PickerAndCalendar.ascx" TagName="PickerAndCalendar" TagPrefix="uc1" %>
<%@ Register Src="../UserControls/AccountDataViewport.ascx" TagName="AccountDataViewport" TagPrefix="uc" %>


<asp:Content ID="Content2" ContentPlaceHolderID="MainContent" Runat="Server">
<script type="text/javascript">
    function toggleCheckBoxState(id, checkState)
    {
        var cb = document.getElementById(id);
        if (cb != null)
            cb.checked = checkState;
    }

    function toggleSelected(checkState)
    {
        // Toggles through all of the checkboxes defined in the CheckBoxIDs array
        // and updates their value to the checkState input parameter
        if (CheckBoxIDs != null)
        {
            for (var i = 0; i < CheckBoxIDs.length; i++)
                toggleCheckBoxState(CheckBoxIDs[i], checkState.checked);
        }
        UpdatePaymentDisplay();
    }
    
    function PaymentsSelected()
    {
        var count = 0;
        for(i = 0; i< document.forms[0].elements.length; i++){
            var e = document.forms[0].elements[i];
            var name = e.name;
            if ((e.type == 'checkbox') && (name.endsWith('SelectPaymentCheckBox')) && (e.checked))
            {
                count ++;
            }
        }
        return (count > 0);
    }
    
    function GetPaymentTotal()
    {
        var total = 0;
        for(i = 0; i< document.forms[0].elements.length; i++){
            var e = document.forms[0].elements[i];
            var name = e.name;
            if ((e.type == 'checkbox') && (name.endsWith('SelectPaymentCheckBox')) && (e.checked))
            {
                var amountFieldName = name.replace('SelectPaymentCheckBox', 'HiddenAmount');
                var amountFieldId = replaceAll(amountFieldName, '$', '_');
                total += parseFloat(document.getElementById(amountFieldId).value);
            }
        }
        
        return total;
    }
    
    function replaceAll(text, strA, strB)
    {
        while ( text.indexOf(strA) != -1)
        {
            text = text.replace(strA,strB);
        }
        return text;
    }
    
    function UpdatePaymentDisplay()
    {
        var total = GetPaymentTotal();
        if (total > 0) {
            document.getElementById('PaymentBatchProcessingInfo').innerHTML = "<strong>Batch Processing: </strong><br>Total Amount of payment(s) to process for your selection(s): <strong>$" + total + "</strong>";
            document.getElementById('BatchProcessingPanel').style.display = "block";
        }
        else {
            document.getElementById('BatchProcessingPanel').style.display = "none";
        }
    }
</script>
<div class="pageHeader">
    <div class="caption">
        <h1><asp:Localize ID="Caption" runat="server" Text="Payment Manager"></asp:Localize></h1>
    </div>
</div>
<ajax:UpdatePanel ID="SearchFormAjax" runat="server">
    <ContentTemplate>
        <div class="searchPanel">
        <table cellpadding="4" cellspacing="0" class="inputForm">
            <tr>
                <th class="rowHeader">
                    <cb:ToolTipLabel ID="DateFilterLabel" runat="server" Text="Date Range:" ToolTip="Filter payments that were placed within the start and end dates." />
                </th>
                <td colspan="3" nowrap>
                    <uc1:PickerAndCalendar ID="StartDate" runat="server" />
                    to <uc1:PickerAndCalendar ID="EndDate" runat="server" />
                    &nbsp;&nbsp;
                    <asp:DropDownList ID="DateQuickPick" runat="server" onchange="alert(this.selectedIndex);">
                        <asp:ListItem Value="-- Date Quick Pick --"></asp:ListItem>
                    </asp:DropDownList>
                </td>
            </tr>
            <tr>
                <th class="rowHeader">
                    <cb:ToolTipLabel ID="PaymentStatusFilterLabel" runat="server" Text="Payment Status:" AssociatedControlID="PaymentStatusFilter" ToolTip="Filter payments by status." />
                </th>
                <td>
                    <asp:DropDownList ID="PaymentStatusFilter" runat="server" AppendDataBoundItems="true">
                        <asp:ListItem Text="All" Value="-1"></asp:ListItem>
                    </asp:DropDownList>
                </td>
                <th class="rowHeader">
                    <cb:ToolTipLabel ID="OrderNumberFilterLabel" runat="server" Text="Order Number(s):" AssociatedControlID="OrderNumberFilter"
                        ToolTip="You can enter order number(s) to filter the list.  Separate multiple orders with a comma.  You can also enter ranges like 4-10 for all orders numbered 4 through 10." />
                </th>
                <td>
                    <asp:TextBox ID="OrderNumberFilter" runat="server" Text="" Width="200px" AutoComplete="off"></asp:TextBox>
                    <cb:IdRangeValidator ID="OrderNumberFilterValidator" runat="server" Required="false"
                        ControlToValidate="OrderNumberFilter" Text="*" ValidationGroup="PaymentManager"
                        ErrorMessage="The range is invalid.  Enter a specific order number or a range of numbers like 4-10.  You can also include mulitple values separated by a comma."></cb:IdRangeValidator>                
                </td>
            </tr>
            <tr>
                <th class="rowHeader">
                    <cb:ToolTipLabel ID="TransactionIdFilterLabel" runat="server" Text="Transaction ID:" AssociatedControlID="TransactionIdFilter"
                        ToolTip="Enter all or part of a transaction id or authorization code to search for." />
                </th>
                <td colspan="3">
                    <asp:TextBox ID="TransactionIdFilter" runat="server" Text="" Width="200px" AutoComplete="off"></asp:TextBox>
                </td>
            </tr>
            <tr>
                <td>&nbsp;</td>
                <td colspan="3">
                    <asp:Button ID="SearchButton" runat="server" Text="Search" OnClick="SearchButton_Click" CausesValidation="false"/>
                    <asp:HyperLink ID="ResetSearchButton" runat="server" Text="Reset" SkinID="Button" NavigateUrl="PaymentManager.aspx"></asp:HyperLink>
                </td>
            </tr>
        </table>
        </div>
    </ContentTemplate>
</ajax:UpdatePanel>
<ajax:UpdatePanel ID="SearchResultAjax" runat="server" UpdateMode="Conditional">
    <ContentTemplate>
        <cb:SortedGridView ID="PaymentGrid" runat="server" SkinID="PagedList" Width="100%" AllowPaging="True" PageSize="20" 
            AllowSorting="True" AutoGenerateColumns="False" DataKeyNames="PaymentId" DataSourceID="PaymentsDs"
            OnRowCommand="PaymentGrid_RowCommand" OnDataBound="PaymentGrid_DataBound" DefaultSortExpression="OrderId" DefaultSortDirection="Descending" 
            ShowWhenEmpty="False" >
            <Columns>
                <asp:TemplateField HeaderText="Select">
                    <HeaderTemplate>
                        <input type="checkbox" onclick="toggleSelected(this)" />
                    </HeaderTemplate>
                    <ItemStyle HorizontalAlign="Center" Width="40px" />
                    <HeaderStyle Width="40px" />
                    <ItemTemplate>
                        <asp:CheckBox ID="SelectPaymentCheckBox" runat="server" Visible='<%# ((PaymentStatus)Eval("PaymentStatus")) == PaymentStatus.Authorized %>' Value='<%# Eval("Amount") %>' onClick="UpdatePaymentDisplay();" />
                        <asp:Literal ID="DummyText" runat="server" Text="X" Visible='<%# ((PaymentStatus)Eval("PaymentStatus")) != PaymentStatus.Authorized %>' ></asp:Literal>
                        <asp:HiddenField ID="HiddenAmount" runat="server" Value='<%# Eval("Amount") %>' />
                    </ItemTemplate>
                </asp:TemplateField>
                <asp:TemplateField HeaderText="Order #" SortExpression="ac_Orders.OrderNumber">
                    <ItemStyle HorizontalAlign="Center" />
                    <ItemTemplate>
                        <asp:HyperLink ID="OrderNumber" runat="server" Text='<%# Eval("Order.OrderNumber") %>' SkinID="Link" NavigateUrl='<%#String.Format("ViewOrder.aspx?OrderNumber={0}&OrderId={1}", Eval("Order.OrderNumber"), Eval("OrderId"))%>'></asp:HyperLink>
                    </ItemTemplate>
                </asp:TemplateField>
                <asp:TemplateField HeaderText="Customer">
                    <ItemStyle HorizontalAlign="Center" />
                    <ItemTemplate>
                        <%#Eval("Order.BillToFirstName")%> <%#Eval("Order.BillToLastName")%>
                    </ItemTemplate>
                </asp:TemplateField>
                <asp:TemplateField HeaderText="Date" SortExpression="ac_Payments.PaymentDate">
                    <ItemStyle HorizontalAlign="Center" />
                    <ItemTemplate>
                        <asp:Label ID="PaymentDate" runat="server" Text='<%# Eval("PaymentDate", "{0:G}") %>'></asp:Label>
                    </ItemTemplate>
                </asp:TemplateField>
                <asp:TemplateField HeaderText="Order Balance">
                    <ItemStyle HorizontalAlign="Center" />
                    <ItemTemplate>
                       <%# GetOrderBalance(Container.DataItem)%>
                    </ItemTemplate>
                </asp:TemplateField>
                <asp:TemplateField HeaderText="Payment Amount" SortExpression="Amount">
                    <ItemStyle HorizontalAlign="Center" />
                    <ItemTemplate>
                       <%# Eval("Amount", "{0:lc}") %>
                    </ItemTemplate>
                </asp:TemplateField>
                <asp:TemplateField HeaderText="Payment Status" SortExpression="ac_Payments.PaymentStatusId">
                    <HeaderStyle HorizontalAlign="Center" />
                    <ItemStyle HorizontalAlign="Center" />
                    <ItemTemplate>
                        <asp:PlaceHolder ID="phPaymentStatus" runat="server"></asp:PlaceHolder>
                        <asp:Label ID="PaymentStatus" runat="server" Text='<%# ((PaymentStatus)Eval("PaymentStatus")).ToString() %>'></asp:Label>
                    </ItemTemplate>
                </asp:TemplateField>
                <asp:TemplateField HeaderText="Last Transaction">
                    <HeaderStyle HorizontalAlign="Left" />
                    <ItemStyle Width="200px" />
                    <ItemTemplate>
                        <%#GetTransactionData(Container.DataItem)%>
                    </ItemTemplate>
                </asp:TemplateField>
                <asp:TemplateField ItemStyle-HorizontalAlign="Right">
                    <ItemTemplate>
                        <asp:ImageButton ID="CaptureButton" runat="server" SkinId="UpdateRate" CommandName="Capture" CommandArgument='<%#Eval("PaymentId")%>' Visible='<%# ((PaymentStatus)Eval("PaymentStatus")) == PaymentStatus.Authorized %>' AlternateText="Capture" ToolTip="Capture" />
                        <asp:HyperLink ID="ViewOrder" runat="server" NavigateUrl='<%# string.Format("Payments/Default.aspx?OrderNumber={0}&OrderId={1}", Eval("Order.OrderNumber"), Eval("OrderId")) %>'><asp:Image ID="PreviewIcon" runat="server" SkinID="PreviewIcon" AlternateText="View Order" ToolTip="View Order" /></asp:HyperLink>
                    </ItemTemplate>
                </asp:TemplateField>
                </Columns>
            <EmptyDataTemplate>
                <asp:Label ID="EmptyMessage" runat="server" Text="No payments match criteria."></asp:Label>
            </EmptyDataTemplate>
        </cb:SortedGridView>
        <div id="BatchProcessingPanel" style="display:none;padding:6px;">
            <br />
            <span id="PaymentBatchProcessingInfo"></span>
            <span id="PaymentTotal"></span>
            <br /><br />
            <asp:Button ID="CaptureAllButton" runat="server" Text="Capture All" OnClick="CaptureAllButton_Click" ValidationGroup="BatchCapture" OnClientClick="if(!PaymentsSelected()){alert('No pament(s) selected. Please select at least one payment.'); return false;}"   />
        </div>
        <asp:HiddenField ID="DummyTarget" runat="server" />
        <asp:Panel ID="CaptureDialog" runat="server" Style="display:none;width:550px" CssClass="modalPopup">
            <asp:Panel ID="CaptureDialogHeader" runat="server" CssClass="modalPopupHeader" EnableViewState="false">
                <asp:Localize ID="CaptureDialogCaption" runat="server" Text="Capture Funds for Payment #{0}: {1}"></asp:Localize>
            </asp:Panel>
            <div style="padding-top:5px;">
                <table class="inputForm" cellpadding="4" cellspacing="0">
                    <tr>
                        <th class="rowHeader">
                            <asp:Label ID="PaymentDateLabel" runat="server" Text="Date:"></asp:Label>
                        </th>
                        <td>
                            <asp:Label ID="PaymentDate" runat="server" Text=""></asp:Label>
                        </td>
                        <th class="rowHeader">
                            <asp:Label ID="AmountLabel" runat="server" Text="Amount:"></asp:Label>
                        </th>
                        <td>
                            <asp:Label ID="Amount" runat="server" Text=""></asp:Label>
                        </td>
                        <th class="rowHeader">
                            <asp:Label ID="PaymentStatusLabel" runat="server" Text="Status:"></asp:Label>
                        </th>
                        <td>
                            <asp:Label ID="CurrentPaymentStatus" runat="server" Text=""></asp:Label>
                        </td>
                    </tr>
                    <tr>
                        <th class="rowHeader" valign="top">
                            <asp:Label ID="AccountDataLabel" runat="server" Text="Method:"></asp:Label>
                        </th>
                        <td colspan="5">
                            <asp:Label ID="PaymentMethod" runat="server"></asp:Label><br />
                            <asp:Label ID="AccountReference" runat="server"></asp:Label>
                        </td>
                    </tr>
                    <tr>
                        <th class="rowHeader" valign="top">
                            <asp:Label ID="AccountDetailsLabel" runat="server" Text="Account Details:" AssociatedControlID="AccountDataViewport" EnableViewState="false"></asp:Label>
                        </th>
                        <td colspan="5">
                            <uc:AccountDataViewport ID="AccountDataViewport" runat="server" EnableViewState="false" UnavailableText="n/a"></uc:AccountDataViewport>
                        </td>
                    </tr>
                    <tr>
                        <th class="sectionHeader" colspan="6" style="text-align:left">
                            <h2><asp:Localize ID="CaptureCaption" runat="server" Text="Capture Options"></asp:Localize></h2>
                        </th>
                    </tr>
                    <tr>
                        <td colspan="6">
                            <table cellpadding="0" cellspacing="5">
                                <tr>
                                    <td>
                                        <asp:Label ID="OriginalAuthorizationLabel" runat="server" Text="Original Authorization:" SkinID="FieldHeader"></asp:Label>
                                    </td>
                                    <td>
                                        <asp:Label ID="OriginalAuthorization" runat="server"></asp:Label>
                                    </td>
                                </tr>
                                <tr runat="server" id="trRemainingAuthorization">
                                    <td>
                                        <asp:Label ID="RemainingAuthorizationLabel" runat="server" Text="Remaining Authorization:" SkinID="FieldHeader"></asp:Label>
                                    </td>
                                    <td>
                                        <asp:Label ID="RemainingAuthorization" runat="server"></asp:Label>
                                    </td>
                                </tr>
                                <tr>
                                    <td>
                                        <asp:Label ID="OrderBalanceLabel" runat="server" Text="Order Balance:" SkinID="FieldHeader"></asp:Label>
                                    </td>
                                    <td>
                                        <asp:Label ID="OrderBalance" runat="server"></asp:Label>
                                    </td>
                                </tr>
                                <tr>
                                    <td>
                                        <asp:Label ID="CaptureAmountLabel" runat="server" Text="Capture Amount:" SkinID="FieldHeader"></asp:Label>
                                    </td>
                                    <td>
                                        <asp:TextBox ID="CaptureAmount" runat="server" Columns="6"></asp:TextBox>
                                    </td>
                                </tr>
                                <tr id="trAdditionalCapture" runat="server">
                                    <td>
                                        <asp:Label ID="AdditionalCaptureLabel" runat="server" Text="Additional Capture Possible:" SkinID="FieldHeader"></asp:Label>
                                    </td>
                                    <td>
                                        <asp:RadioButton ID="AdditionalCapture" runat="server" GroupName="AdditionalCapture" Text="Yes" />(option to capture additional funds on this authorization if needed)<br />
                                        <asp:RadioButton ID="NoAdditionalCapture" runat="server" GroupName="AdditionalCapture" Text="No" Checked="true" /> (no additional capture needed; close authorization after this capture)<br />
                                    </td>
                                </tr>
                                <tr>
                                    <td>
                                        <asp:Label ID="CustomerNoteLabel" runat="server" Text="Note to Customer:" SkinID="FieldHeader"></asp:Label><br />
                                        (Optional)
                                    </td>
                                    <td>
                                        <asp:TextBox ID="CustomerNote" runat="server" TextMode="MultiLine" Rows="6" Columns="50"></asp:TextBox>
                                    </td>
                                </tr>
                                <tr>
                                    <td colspan="2" align="center">
                                        <asp:HiddenField ID="HiddenPaymentId" runat="server" />
                                        <asp:Button ID="SubmitCaptureButton" runat="server" Text="Capture" OnClick="SubmitCaptureButton_Click"></asp:Button>
                                        <asp:Button ID="CancelCaptureButton" runat="server" Text="Cancel" CausesValidation="false"></asp:Button>
                                    </td>
                                </tr>
                            </table>
                        </td>
                    </tr>
                </table>
            </div>
        </asp:Panel>
        <ajax:ModalPopupExtender ID="CapturePopup" runat="server" 
            TargetControlID="DummyTarget"
            PopupControlID="CaptureDialog" 
            BackgroundCssClass="modalBackground"                         
            CancelControlID="CancelCaptureButton" 
            DropShadow="false"
            PopupDragHandleControlID="CaptureDialogHeader" />
    </ContentTemplate>
</ajax:UpdatePanel>            
<asp:ObjectDataSource ID="PaymentsDs" runat="server" OldValuesParameterFormatString="original_{0}"
    SelectMethod="Load" SelectCountMethod="Count" SortParameterName="sortExpression" TypeName="CommerceBuilder.Search.PaymentFilterDataSource"
    OnSelecting="PaymentsDs_Selecting" EnablePaging="true">
    <SelectParameters>
        <asp:Parameter Name="filter" Type="Object" />
    </SelectParameters>
</asp:ObjectDataSource>
</asp:Content>

